﻿Module Module1

    '車の状態を表示するメソッド
    Public Sub ShowMeter(car As Vehicle)
        'コンソールの表示を消す
        Console.Clear()

        '各プロパティの内容を表示する
        Console.WriteLine("スピード：{0}km/h", car.Speed)
        Console.WriteLine("ガソリン：{0}L", car.Gas)
    End Sub

    Sub Main()
        '選択メニューを表示
        Console.WriteLine("走らせる車の種類を選んでください。")
        Console.Write("1)スポーツカー　2)タクシー：")
        Dim inputdata As String = Console.ReadLine()

        '選択した車オブジェクトを生成
        Dim car As Vehicle
        Dim driver As TestDriver
        If inputdata = 1 Then
            'スポーツカーとテストドライバーを生成
            car = New SportsCar(60)
            driver = New TestDriver(car, 20)
        ElseIf inputdata = 2 Then
            'タクシーとテストドライバーを生成
            car = New Taxi(50, 60)
            driver = New TestDriver(car, 5)
        Else
            Console.WriteLine("車を作れませんでした。")
            Console.ReadLine()
            Return
        End If

        '状態を表示
        ShowMeter(car)

        While True
            '操作を入力
            Console.Write("1)加速　2)減速　9)終了：")
            inputdata = Console.ReadLine()

            '操作によって分岐する
            Select Case inputdata
                Case "1"
                    '加速する
                    driver.SpeedUp()
                    ShowMeter(car)
                Case "2"
                    '減速する
                    driver.SpeedDown()
                    ShowMeter(car)
                Case "9"
                    'プログラムを終了する
                    Return
                Case Else
                    ShowMeter(car)
            End Select
        End While
    End Sub

End Module
