﻿Public MustInherit Class Vehicle
    'プロパティ==========
    Public Property Speed As Integer
    Public Property Gas As Double

    'コンストラクタ==========
    Public Sub New()
        Me.New(20)
    End Sub

    Public Sub New(gas As Double)
        Me.Speed = 0
        Me.Gas = gas
    End Sub

    'メソッド==========
    '加速するメソッド(抽象メソッド)
    Public MustOverride Sub SpeedUp(sp As Integer)

    '減速するメソッド
    Public Sub SpeedDown(sp As Integer)
        'スピードを減らす
        Me.Speed -= sp
        If Me.Speed < 0 Then    'スピードがマイナスになる場合
            'スピードを0に補正する
            Me.Speed = 0
        End If
    End Sub
End Class
